<?php
/**
 * DOCman 1.4.x - Joomla! Document Manager
 * @version $Id: README.php 428 2007-10-30 10:16:48Z mjaz $
 * @package DOCman_1.4
 * @copyright (C) 2003-2007 The DOCman Development Team
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.joomlatools.org/ Official website
 **/
defined('_VALID_MOS') or die('Restricted access');
?>

DOCman v1.4.0 RC1 README
-------------------------

*** IMPORTANT ***

PLEASE READ THE UPGRADE INSTRUCTIONS BELOW WHEN UPGRADING FROM AN OLDER VERSION!

ALWAYS BACK UP YOUR SYSTEM'S FILES AND DATABASE BEFORE (UN)INSTALLING ANYTHING!

TO MAKE SURE THE FILES HAVEN'T BEEN TAMPERED WITH, DOWNLOAD DOCMAN, ADDONS AND
TRANSLATIONS FROM THE ORIGINAL LOCATION AT http://joomlacode.org/gf/project/docman/

About DOCman
------------
DOCman is an open source document management and download system for Joomla! v1.0.x and v1.5. With this component you can manage documents across categories and make them available for download.

These are the main features of DOCman:

* Infinite categories and subcategories. The documents can be organized across custom categories and subcategories;
* Files can be hosted locally or on a remote server
* Access control: Documents can be assigned to specific user or to custom groups of users
* Download counter and log. You can display a download counter per document and all the downloads can be logged (by user, IP, browser, date and hour);
* Own search system. Documents can be searched by name and/or description. The search system integrates with Joomla! using an optional mambot;
* Anti-leech system. The built-in anti-leech system avoids direct linking to documents;
* Path protection. Real paths to documents are never displayed to users;
* Themes: The layout can be changed using custom themes;
* ... and much more!


New features in  v1.4.0 RC1
--------------------------
* SEF / Human readable urls (J!1.5 only)
* The task buttons are now pluggable
* Checked out documents are now colour-coded
* Special Compatibility Mode: The "Special" group now optionally behaves as in DOCman 1.3 or as in Joomla!
* Performance improvements
* Various fixes to improve Joomla! v1.5 support

New features in  v1.4.0 BETA2
----------------------------
* Compatible with Joomla! v1.5 (using legacy mode)
* Document and Category descriptions can use content mambots (optional)
* Reworked user interface
* Uninstalling or reinstalling preserves your data. Instead, data can be removed using the new 'Clear Data' feature
* Simple progress bar during upload
* Pathway integrates with Joomla
* 'Unapproved documents' admin module
* Themes can have separate icons for browsers that don't support PNG alpha transparency
* Huge performance improvements!
* Some minor security issues were fixed, about a hundred language strings were added and about a hundred other bugs were fixed. Please see the included CHANGELOG.php for a (near) complete list.

Installation in Joomla! 1.0.x
-----------------------------
1. Check your writing permissions. [System -> System Info -> Permissions]
2. Install DOCman using Joomla's component installer. [Installers -> Components]
3. If you're new to DOCman, we highly recommend you click the 'Add sample data'-button.
4. Review the configuration settings and save.
5. To use the integrated search, install the optional search mambot and publish it.

Installation in Joomla! 1.5.x
-----------------------------
DOCman only works with Joomla! v1.5RC3 or later.
1. Turn on legacy mode. [Extensions -> Plugin Manager, publish the item 'System - Legacy']
1. Check your writing permissions. [Help -> System Info -> Directory Permissions]
2. Install DOCman using Joomla's installer. [Extensions -> Install/Uninstall]
3. If you're new to DOCman, we highly recommend you click the 'Add sample data'-button.
4. Review the configuration settings and save.
5. To use the integrated search, install the optional search mambot and publish it.

Upgrading from v1.3 RC2
-----------------------
Please follow these instructions carefully to make sure no data is lost.
1. Install com_patch_docman_v13rc2.zip using Joomla's component installer.
2. [Optional] Make a backup copy of /administrator/components/com_docman/docman.config.php to a different location
3. [Optional] If you have custom themes, make sure you backup these separately. They're in /components/com_docman/themes
4. Uninstall DOCman 1.3 RC2. Your files, documents, categories, licenses, logs and groups will be preserved.
5. Uninstall docman13rc2_patch
6. Install the latest version of DOCman
7. [Optional] Restore docman.config.php and your theme
8. Review the configuration settings and save
9. [Optional] Uninstall old addons and install the new versions

Note: Reverting to v1.3RC2 after installing v1.4 will cause you to loose your data. Take precautions!

Upgrading from v1.4.0 ALPHA or later
------------------------------------
If you have any version of 1.4.x, you can always upgrade to the latest version without loosing your data, EXCEPT the config settings and the theme.
1. [Optional] Make a backup copy of /administrator/components/com_docman/docman.config.php to a different location
2. [Optional] If you have custom themes, make sure you backup these separately They're in /components/com_docman/themes
3. Uninstall DOCman 1.4.x Your files, documents, categories, licenses, logs and groups will be preserved.
4. Install the latest version of DOCman
5. [Optional] Restore docman.config.php and your theme
6. Review the configuration settings and save
7. [Optional] Uninstall old addons and install the new versions

Official Addons
---------------
These are currently available from the official site:
* DOCLink
  Joomla editor plugin that allows the insertion of links to DOCman files using a popup dialog.
* DOCman Search
  Mambot for searching DOCman Files
* mod_docman_catdown
  Shows the documents from one specific category
* mod_docman_latestdown
  Shows the latest added documents
* mod_docman_lister
  Show a list of popular/latest documents
* mod_docman_mostdown
  Show the most downloaded documents

Useful Links
------------
* Official Site:
  http://www.joomlatools.org

* Joomla!Code Project Site:
  http://joomlacode.org/gf/project/docman

* Download the latest version and add-ons:
  http://joomlacode.org/gf/project/docman/frs/

* Get help and help others on the forum:
  http://forum.joomlatools.org

* Report bugs and feature requests:
  http://joomlacode.org/gf/project/docman/tracker/

* Vote at the Joomla! Extensions Directory
  http://extensions.joomla.org/component/option,com_mtree/task,viewlink/link_id,82/Itemid,35/

* Vote at Ohloh
  http://www.ohloh.net/projects/6141?p=Joomlatools
