<?php
/**
 * DOCman 1.4.x - Joomla! Document Manager
 * @version $Id: DOCMAN_model.class.php 431 2007-11-01 10:57:41Z mjaz $
 * @package DOCman_1.4
 * @copyright (C) 2003-2007 The DOCman Development Team
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.joomlatools.org/ Official website
 **/
defined('_VALID_MOS') or die('Restricted access');

if (defined('_DOCMAN_MODEL')) {
    return;
} else {
    define('_DOCMAN_MODEL', 1);
}

require_once($_DOCMAN->getPath('classes', 'utils'));

class DOCMAN_Model
{
    var $objDBTable = null;

    var $objFormatData = null;
    var $objFormatLink = null;
    var $objFormatPath = null;

    function DOCMAN_Model()
    {
        $this->objFormatData = new stdClass();
        $this->objFormatLink = new stdClass();
        $this->objFormatPath = new stdClass();
    }

    function getLink($identifier)
    {
        if (isset($this->objFormatLink->$identifier))
            return $this->objFormatLink->$identifier;
        else
            return null;
    }

    function getPath($identifier)
    {
        if (isset($this->objFormatPath->$identifier))
            return $this->objFormatPath->$identifier;
        else return null;
    }

    function getData($identifier)
    {
        if (isset($this->objFormatData->$identifier))
            return $this->objFormatData->$identifier;
        else
            return null;
    }

    function setData($identifier, $data)
    {
        $this->objFormatData->$identifier = $data;
    }

    function &getLinkObject()
    {
        return $this->objFormatLink;
    }

    function &getPathObject()
    {
        return $this->objFormatPath;
    }

    function &getDataObject()
    {
        return $this->objFormatData;
    }

    function getDBObject()
    {
        return $this->objDBTable;
    }

    function _format($objDBTable)
    {
    }

    function _formatLink($task, $params = null, $sef = true, $indexfile = 'index.php')
    {
        $link = DOCMAN_Utils::taskLink($task, $this->objDBTable->id, $params, $sef, $indexfile );
        return $link;
    }
}

class DOCMAN_Category extends DOCMAN_Model
{
    function DOCMAN_Category($id)
    {
        // using getInstance for performance
        // global $database;
        // $this->objDBTable = new mosDMCategory($database);
        // $this->objDBTable->load($id);
        $this->objDBTable = & mosDMCategory::getInstance( $id );

        $this->_format($this->objDBTable);
    }

    function getPath($identifier, $type = 1, $param = null, $png = 1)
    {
        $result = null;

        switch ($identifier) {
            case 'icon' :
                $result = DOCMAN_Utils::pathIcon ('folder.png', $type, $param, $png);
                break;

            default :
                $result = parent::getPath($identifier);
        }

        return $result;
    }

    function _format(&$objDBCat)
    {
        global $_DOCMAN;

        $user = $_DOCMAN->getUser();
        // format category data
        $this->objFormatData = DOCMAN_Utils::get_object_vars($objDBCat);

        $this->objFormatData->files = DOCMAN_Cats::countDocsInCatByUser($objDBCat->id, $user, true);
        // format category links
        $this->objFormatLink->view = $this->_formatLink('cat_view');
        // format category paths
        $this->objFormatPath->thumb = DOCMAN_Utils::pathThumb($objDBCat->image);
        $this->objFormatPath->icon = DOCMAN_Utils::pathIcon ('folder.png', 1);
    }
}

class DOCMAN_Document extends DOCMAN_Model
{
    function DOCMAN_Document($id)
    {
        global $database;
        $this->objDBTable = new mosDMDocument($database);
        $this->objDBTable->load($id);

        $this->_format($this->objDBTable);
    }

    function & getInstance($id) {
    	static $instances;
        if(!isset($instances)) {
            $instances = array();
        }

        if(!isset($instances[$id])) {
        	$instances[$id] = new DOCMAN_Document($id);
        }

        return $instances[$id];
    }

    function getPath($identifier, $type = 1, $param = null)
    {
        $result = null;

        switch ($identifier) {
            case 'icon' :
                $result = DOCMAN_Utils::pathIcon ($this->objFormatData->filetype . ".png", $type, $param);
                break;

            default :
                $result = parent::getPath($identifier);
        }

        return $result;
    }

    function _format(&$objDBDoc)
    {
        global $_DOCMAN;

        $user = $_DOCMAN->getUser();

        require_once($_DOCMAN->getPath('classes', 'file'));
        $file = new DOCMAN_file($objDBDoc->dmfilename, $_DOCMAN->getCfg('dmpath'));

        require_once($_DOCMAN->getPath('classes', 'params'));
        $params = & new dmParameters( $objDBDoc->attribs, '' , 'params' );

        // format document data
        $this->objFormatData = DOCMAN_Utils::get_object_vars($objDBDoc);

        $this->objFormatData->owner 			= $this->_formatUserName($objDBDoc->dmowner);
        $this->objFormatData->submited_by 		= $this->_formatUserName($objDBDoc->dmsubmitedby);
        $this->objFormatData->maintainedby 		= $this->_formatUserName($objDBDoc->dmmantainedby);
        $this->objFormatData->lastupdatedby 	= $this->_formatUserName($objDBDoc->dmlastupdateby);
        $this->objFormatData->checkedoutby 		= $this->_formatUserName($objDBDoc->checked_out);
        $this->objFormatData->filename 			= $this->_formatFilename($objDBDoc);
        $this->objFormatData->filesize 			= $file->getSize();
        $this->objFormatData->filetype 			= $file->ext;
        $this->objFormatData->mime 				= $file->mime;
        $this->objFormatData->hot               = $this->_formatHot($objDBDoc);
        $this->objFormatData->new               = $this->_formatNew($objDBDoc);
        $this->objFormatData->state 			= $this->objFormatData->new.' '.$this->objFormatData->hot; //for backwards compat with 1.3
        $this->objFormatData->params			= $params;

        // @TODO Move all of this to a button plugin
        // format document links ONLY those the user can perform.
        require_once($_DOCMAN->getPath('classes', 'button'));
        $_DOCMAN->loadLanguage('frontend');
        $buttons = array();

        if ($user->canDownload($objDBDoc)) {
            // Download
            $buttons['download'] = new DOCMAN_Button('download', _DML_BUTTON_DOWNLOAD, $this->_formatLink('doc_download'));

            // View
            $viewtypes = trim($_DOCMAN->getCfg('viewtypes'));
            if ($viewtypes != '' && ($viewtypes == '*' || stristr($viewtypes, $file->ext))) {
                $link = $this->_formatLink('doc_view', null, true, 'index2.php');
                $params = new DMmosParameters('popup=1');
                $buttons['view'] = new DOCMAN_Button('view', _DML_BUTTON_VIEW, $link, $params);
            }
        }

        $buttons['details'] = new DOCMAN_Button('details', _DML_BUTTON_DETAILS, $this->_formatLink('doc_details'));


        if ($user->canEdit($objDBDoc)) {
            $buttons['edit'] = new DOCMAN_Button('edit', _DML_BUTTON_EDIT, $this->_formatLink('doc_edit'));
        }

        if ($user->canMove($objDBDoc)) {
            $buttons['move'] = new DOCMAN_Button('move', _DML_BUTTON_MOVE, $this->_formatLink('doc_move'));
        }

        if ($user->canDelete($objDBDoc)) {
            $buttons['delete'] = new DOCMAN_Button('delete', _DML_BUTTON_DELETE, $this->_formatLink('doc_delete'));
        }

         if ($user->canUpdate($objDBDoc)) {
            $buttons['update'] = new DOCMAN_Button('update', _DML_BUTTON_UPDATE, $this->_formatLink('doc_update'));
        }

        if ($user->canReset($objDBDoc)) {
            $buttons['reset'] = new DOCMAN_Button('reset', _DML_BUTTON_RESET, $this->_formatLink('doc_reset'));
        }

        if ($user->canCheckin($objDBDoc) && $objDBDoc->checked_out) {
            $params = new DMmosParameters('class=checkin');
            $buttons['checkin'] = new DOCMAN_Button('checkin', _DML_BUTTON_CHECKIN, $this->_formatLink('doc_checkin'), $params);
        }

        if ($user->canCheckout($objDBDoc) && !$objDBDoc->checked_out) {
            $buttons['checkout'] = new DOCMAN_Button('checkout', _DML_BUTTON_CHECKOUT, $this->_formatLink('doc_checkout'));
        }

        if ($user->canApprove($objDBDoc) && !$objDBDoc->approved) {
            $params = new DMmosParameters('class=approve');
            $buttons['approve'] = new DOCMAN_Button('approve', _DML_BUTTON_APPROVE, $this->_formatLink('doc_approve'), $params);
        }

        if ($user->canPublish($objDBDoc)) {
            $params = new DMmosParameters('class=publish');
            $buttons['publish'] = new DOCMAN_Button('publish', _DML_BUTTON_PUBLISH, $this->_formatLink('doc_publish'), $params);
        }

        if ($user->canUnPublish($objDBDoc)) {
            $buttons['unpublish'] = new DOCMAN_Button('unpublish', _DML_BUTTON_UNPUBLISH, $this->_formatLink('doc_unpublish'));
        }

        // onFetchButtons event
        // plugins should always return an array of Button objects
        require_once($_DOCMAN->getPath('classes', 'mambots'));
        $bot = new DOCMAN_mambot('onFetchButtons');
        $bot->setParm('doc' , $objDBDoc);
        $bot->trigger();
        if ($bot->getError()) {
            _returnTo('cat_view', $bot->getErrorMsg());
        }
        foreach( $bot->getReturn() as $return) {
        	$buttons = array_merge($buttons, $return);
        }

        $this->objFormatLink = & $buttons;


        // format document paths
        $this->objFormatPath->icon = DOCMAN_Utils::pathIcon ($file->ext . ".png", 1);
        $this->objFormatPath->thumb = DOCMAN_Utils::pathThumb($objDBDoc->dmthumbnail, 1);
    }

    //  @desc Translate the numeric ID to a character string
    //  @param integer $ The numeric ID of the user
    //  @return string Contains the user name in string format
    function _formatUserName($userid)
    {
        global $database;

        switch ($userid)
        {
            case '-1':
                return _DML_EVERYBODY;
                break;
            case '0':
                return _DML_ALL_REGISTERED;
                break;
            case _DM_PERMIT_PUBLISHER:
                return _DML_GROUP_PUBLISHER;
                break;
            case _DM_PERMIT_EDITOR:
                return _DML_GROUP_EDITOR;
                break;
            case _DM_PERMIT_AUTHOR:
                return _DML_GROUP_AUTHOR;
                break;
            default:

                if ($userid > 0)
                {
                    // $user = new mosUser($database);
                    // $user->load($userid);
                    // return $user->username;

                    // performance improvement
                    $users = & DOCMAN_users::getList();
                    return $users[$userid]->username;
                }

				if($userid < -5)
				{
      				$calcgroups = (abs($userid) - 10);

      				$group = new mosDMGroups($database);
                    $group->load($calcgroups);
        			return $group->groups_name;
				}
                break;
        }

        return "USER ID?";
    }

    /*
     * Replaced by _formatNew and _formatHot
    function _formatState(&$objDBDoc)
    {
        global $_DOCMAN;

        $days = $_DOCMAN->getCfg('days_for_new');
        $hot = $_DOCMAN->getCfg('hot');

        $result = null;

        if ($days > 0 &&
            (DOCMAN_Utils::Daysdiff ($objDBDoc->dmdate_published) > ($days -2 * $days)) && (DOCMAN_Utils::Daysdiff ($objDBDoc->dmdate_published) <= 0)) {
            $result = _DML_NEW;
        }

        if ($hot > 0 && $objDBDoc->dmcounter >= $hot) {
            $result .= _DML_HOT;
        }

        return $result;
    }
    */

    function _formatNew(&$objDBDoc){
        global $_DOCMAN;
        $days = $_DOCMAN->getCfg('days_for_new');
        $result = null;

        if ($days > 0 &&
            (DOCMAN_Utils::Daysdiff ($objDBDoc->dmdate_published) > ($days -2 * $days)) && (DOCMAN_Utils::Daysdiff ($objDBDoc->dmdate_published) <= 0)) {
            $result = _DML_NEW;
        }
        return $result;
    }

    function _formatHot(&$objDBDoc){
        global $_DOCMAN;
        $hot = $_DOCMAN->getCfg('hot');
        $result = null;

        if ($hot > 0 && $objDBDoc->dmcounter >= $hot) {
            $result = _DML_HOT;
        }

        return $result;
    }



    function _formatFilename( &$objDBDoc)    {
        global $_DOCMAN;
        $_DMUSER = $_DOCMAN->getUser();

        $filename = $objDBDoc->dmfilename;
        $is_link = (  substr($filename, 0, strlen(_DM_DOCUMENT_LINK)  ) == _DM_DOCUMENT_LINK );
        $hide_remote = $_DOCMAN->getCfg( 'hide_remote', 1 );
        $can_edit = $_DMUSER->canEdit( $objDBDoc );


        if( $is_link AND $hide_remote AND !$can_edit )  {
            // strip 'Link: '
            $filename = ereg_replace( '^'._DM_DOCUMENT_LINK, '', $filename) ;

            // strip scheme (http://, ftp:// )
            $filename = ereg_replace( '^[a-zA-Z]+://', '', $filename);

            if( strpos( $filename, '/' )) { // format www.mysite.com/ or www.mysite.com/path/ or www.mysite.com/path/myfile.com
                // strip domain (www.mysite.com )
                $filename = ereg_replace( '^(([.]?[a-zA-Z0-9_-])*)/', '/', $filename);
                // strip path
                $filename = substr( $filename, strrpos( $filename, '/')+1 );
            } else { // format www.mysite.com (no trailing slash or path or filename)
            	$filename ='';
            }

            // if there's nothing left, we mark it 'unknown'
            $filename = ( $filename ? _DML_LINKTO.$filename : _DML_UNKNOWN );

        }

        return $filename;
    }
}