<?php
/**
 * DOCman 1.4.x - Joomla! Document Manager
 * @version $Id: docman.php 378 2007-10-10 07:41:04Z mjaz $
 * @package DOCman_1.4
 * @copyright (C) 2003-2007 The DOCman Development Team
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.joomlatools.org/ Official website
 **/
defined('_VALID_MOS') or die('Restricted access');

include_once dirname(__FILE__) . '/docman.html.php';

switch ($task) {
    case 'stats':
        showStatistics();
        break;

    case 'credits' :
        showCredits();
        break;

    case 'sampledata':
        installSampleData();
        break;

    // DOClink
    case "doclink":
        require_once($_DOCMAN->getPath('includes_f', 'doclink'));
        showDoclink();
        break;

    case "doclink-listview":
        require_once($_DOCMAN->getPath('includes_f', 'doclink'));
        showListview();
        break;

    // CPanel
    case 'cpanel':
    default:
        showCPanel();
}

function showCPanel()
{
    HTML_DMDocman::showCPanel();
}

function showCredits()
{
    global $mosConfig_absolute_path;

    ob_start();
    include( $mosConfig_absolute_path.'/administrator/components/com_docman/CHANGELOG.php' );
    $changelog = ob_get_clean();

    HTML_DMDocman::showCredits( $changelog );
}

function showStatistics()
{
    global $database;
    $query = "SELECT id, catid , dmname , dmcounter from #__docman " .
            // removed to fix artf7530
            // "\n WHERE dmowner=-1 OR dmowner=0 " .
            "\n ORDER BY dmcounter DESC";
    $database->setQuery($query, 0, 50);
    $row = $database->loadObjectList();
    HTML_DMDocman::showStatistics($row);
}

/**
 * Add sample category, file and document
 */
function installSampleData(){
    global $database, $my, $mosConfig_absolute_path;
    $dmdoc  = $mosConfig_absolute_path.DS.'dmdocuments';
    $img    = $mosConfig_absolute_path.DS.'administrator'.DS.'components'.DS.'com_docman'.DS.'images';
    $now = date('Y-m-d H:i:s');

    // get all super admins
    $database->setQuery("SELECT id FROM `#__users` WHERE `usertype`='Super Administrator'");
    $admins = implode(',', $database->loadResultArray() );

    // add sample group
    $database->setQuery("INSERT INTO `#__docman_groups`" .
                        "\n (`groups_id`, `groups_name`, `groups_description`, `groups_access`, `groups_members`)" .
                        "\n VALUES (NULL, '"._DML_SAMPLE_GROUP."', '"._DML_SAMPLE_GROUP_DESC."', 1, '$admins');");
    $database->query();
    $groupid = (-1 * $database->insertid()) + _DM_PERMIT_GROUP;

    // add sample license
    $database->setQuery("INSERT INTO `#__docman_licenses`" .
                        "\n ( `id` , `name` , `license` )" .
                        "\n VALUES (NULL , '"._DML_SAMPLE_LICENSE."', '"._DML_SAMPLE_LICENSE_DESC."');");
    $database->query();
    $licenseid = $database->insertid();

    // add a sample file
    if ( !file_exists($dmdoc.DS.'sample_file.png')) {
       @copy($img.DS.'dm_logo.png', $dmdoc.DS._DML_SAMPLE_FILENAME);
    }

    // add sample category
    $database->setQuery("INSERT INTO `#__categories`" .
            "\n ( `id` , `parent_id` , `title` , `name` , `image` , `section` , `image_position` , `description` , `published` , `checked_out` , `checked_out_time` , `editor` , `ordering` , `access` , `count` , `params` )" .
            "\n VALUES ( NULL , 0, '"._DML_SAMPLE_CATEGORY."', '"._DML_SAMPLE_CATEGORY."', 'clock.jpg', 'com_docman', 'left', '"._DML_SAMPLE_CATEGORY_DESC."', 1, 0, '0000-00-00 00:00:00', NULL , 1, 0, 0, '' );" );
    $database->query();
    $catid = $database->insertId();

    // add sample document
    $database->setQuery("INSERT INTO `#__docman`" .
            "\n ( `id` , `catid` , `dmname` , `dmdescription` , `dmdate_published` , `dmowner` , `dmfilename` , `published` , `dmurl` , `dmcounter` , `checked_out` , `checked_out_time` , `approved` , `dmthumbnail` , `dmlastupdateon` , `dmlastupdateby` , `dmsubmitedby` , `dmmantainedby` , `dmlicense_id` , `dmlicense_display` , `access` , `attribs` )" .
            "\n VALUES ( NULL , $catid, '"._DML_SAMPLE_DOC."', '"._DML_SAMPLE_DOC_DESC."', '$now', -1, '"._DML_SAMPLE_FILENAME."', 1, '', 0, 0, '0000-00-00 00:00:00', 1, '', '$now', {$my->id}, {$my->id}, $groupid, $licenseid, 1, 0, 'crc_checksum=\nmd5_checksum=');");
    $database->query();






    mosRedirect('index2.php?option=com_docman', _DML_SAMPLE_COMPLETED);
}
