<?php
/**************************************
 * File: mod_exposescroller.php
 * Expose Thumbnail Scroller
 **************************************
 * @ package Joomla! Open Source
 * @ Released under GNU/ GPL license
 * @ Author Bruno Marchant
 * @ version Beta 1.0 on 13/10/2007
 * @ Module based on:
 * @   Joomla Random Picture module and
 * @   RS2 Thumbnail Scroller by Daniel Tulp, witch is based on: 
 * @     RSgallery thumbnailscroller by J van Kranenburg, which is based on:
 * @       AKO Gallery Thumbnail Scroller
 **************************************/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $mosConfig_absolute_path, $mosConfig_live_site, $ExposeImgPath;

// Retrieve the parameters
$setPath			= $params->get('ImagePath','0');
$setRecurceDirs 	= $params->get('SubDirs','1');
$setFileType 		= $params->get('type','\.(jpg|gif|png)$'); // Set eregi() string type (search for specific file patterns)
$setLinking 		= $params->get('Linking','album');
$setHoverPause		= $params->get('Pause','1');
$setWidth			= $params->get('Width','80'); // Don't use intval(), so user can type 100%
$setHeight			= $params->get('Height','100');
$setPicsNum			= intval($params->get('PicsNum','10'));
$setPickMethod		= trim  ($params->get('PickMethod','random'));
$setDirection		= trim  ($params->get('Direction','left'));
$setMarqueeAmount	= intval($params->get('Amount','2'));
$setMarqueeDelay	= intval($params->get('Delay','50'));
$setSpace			= intval($params->get('Space','2'));
$setBugSpace		= intval($params->get('BugSpace','10'));
$setUseCss			= $params->get('UseCss','1');
$setCssDef			= $params->get('Css');

// Predefigned things
$ExposeXmlPath = "$mosConfig_absolute_path/components/com_expose/expose/xml/";
$ExposeImgPath = "/components/com_expose/expose/img/";

// add XML library functions
require_once( $mosConfig_absolute_path.'/includes/domit/xml_domit_include.php' );

//******************
// Search for files with specific extention in current and subfolders. Snippet from phpbuilder.com
/* recursive_dir(	rootdirectory to start search in,
			 file extension to search for (if left blank then will show all files -- eregi() function setting),
			 new subfolder to continou search in (code only),
			 array with all files found (with subdirectoryinfo addad to filepath)
			 search also in subfolders )
*/
if(!function_exists('recursive_dir')) {
	function recursive_dir($root, $check_ext = "jpg", $new_path_ext = "", &$array, $InSub = "1", &$piccounter) {
		// to check: mosReadDirectory function
		$dh = opendir($root.$new_path_ext);
		//keep reading as long as files are found
		while(false !== ($entry=readdir($dh))) {
			//if subdirectory found, recall this function
			if($entry != "." && $entry != ".." && is_dir($root.$new_path_ext.$entry) && $InSub) {
				recursive_dir($root,$check_ext,$new_path_ext.'/'.$entry, $array, $InSub, $piccounter);
			}  
			//if picture file found and matching the user-filter, then add it to array 
			elseif($entry != "." && $entry != ".." && eregi("($check_ext)$",$entry)) {
				$array_ptr = &$array[$piccounter];
				$array_ptr['smallimage'] = $new_path_ext.'/'.$entry;
				$array_ptr['timestamp'] = filemtime($root.$new_path_ext.'/'.$entry);
				$array_ptr['title'] = $entry;
//				$array_ptr['albumid'] = '';  //trap undefigned variable error
				$piccounter++;
			}
		}
		closedir($dh);
		return $piccounter;
	}
}

// *******  Open a XML file with domit for reading
if(!function_exists('domopen_file')) {
	function domopen_file($xmlfile) {
		$domfile =& new DOMIT_Document();
 		$domfile->resolveErrors(true);
		//first, check if file exists, then open it
 		if (file_exists($xmlfile)) {
			if (!$domfile->loadXML($xmlfile)) {
				echo "Error loading the xml file\n<br>";
				echo "Code: ".$domfile->getErrorCode()."\n<br>";
				echo "Errorstring: ".$domfile->getErrorString()."\n<br>";
				return "";
				break;
			}
		}
//		else {
// 			echo "Error loading the xml file\n<br>";
//			echo "Code: File not found ".$xmlfile."\n<br>";
//			return "";
//			break; 	
//		 }
		return $domfile;
	}
}	

// *******  http://be2.php.net/domxml
if(!function_exists('domread_collection')) {
	function domread_collection($domnode, &$array, &$piccounter) {
		static $prenode = 0;

		$array_ptr = &$array;
		$domnode = $domnode->firstChild;
		while (!is_null($domnode)) {
			switch ($domnode->nodeType) {
				case XML_TEXT_NODE: {
					//Create array with $prenode as arrayName and nodeValue as arrayValue if elementNode has been created
//					 echo "piccounter: ".$piccounter. " Name: ".$prenode." = ".$domnode->nodeValue."\n<br>";
					$array_ptr[$prenode] = $domnode->nodeValue;
					//break;
				}
				case XML_ELEMENT_NODE: {
					//Store nodename name for arrayName
					if ($domnode->nodeName != "url") $prenode = $domnode->nodeName;					
					//if xml-tag = 'album' with attribute = '_mngid' then create subarray			 
					if (($prenode == "album") && ($domnode->hasAttribute("_mngid"))) {		
						// pointername is albumid 
						$array_ptr = &$array[$domnode->getAttribute("_mngid")];
						$piccounter++;
					}
					//break;
				}
			}
			if ( $domnode->hasChildNodes() ) {
				//recall this function to search in subNodes
				domread_collection($domnode, $array_ptr, $piccounter);
			}
			//goto next node	 
			$domnode = $domnode->nextSibling;
		}
		return $piccounter;
	}
}

if(!function_exists('domread_album')) {
	function domread_album($domnode, &$array, &$albumid, &$piccounter) {
		global $mosConfig_absolute_path, $ExposeImgPath;
		static $prenode = 0;

		$array_ptr = &$array;
		$domnode = $domnode->firstChild;
		while (!is_null($domnode)) {
			switch ($domnode->nodeType) {
				case XML_TEXT_NODE: {
					//Create array with $prenode as arrayName and nodeValue as arrayValue
//					 echo "piccounter: ".$piccounter." Value Name: ".$prenode." = ".$domnode->nodeValue."\n<br>";
					//If image is a movie, then change array name to imagetag
					if ($prenode == 'thumb') $prenode = 'smallimage';
					$array_ptr[$prenode] = $domnode->nodeValue;
					if ($prenode == 'smallimage') {
					//check if file exists, and get its timestamp
//					echo $mosConfig_absolute_path.$ExposeImgPath.$domnode->nodeValue."\n<br>";
						if (file_exists($mosConfig_absolute_path.$ExposeImgPath.$domnode->nodeValue)) {
							$array_ptr["timestamp"] = filemtime($mosConfig_absolute_path.$ExposeImgPath.$array_ptr[$prenode]);
						}
					}
					//break;
				}
				case XML_ELEMENT_NODE: {
					//Store nodename name for arrayName
//					 echo "Node Name: ".$domnode->nodeName." = ".$domnode->nodeValue."\n<br>";
					if ($domnode->nodeName != "url") $prenode = $domnode->nodeName;
					//if the tag = 'album' with attribute = '_mngid' then create subarray			 
					if (($prenode == "picture") || ($prenode == "video")) {
						if ($domnode->hasAttribute("_mngid")) {
							$array_ptr = &$array[$piccounter];
							$array_ptr["photoid"] = $domnode->getAttribute("_mngid");
							$array_ptr["albumid"] = $albumid;
							$array_ptr["title"] = '';
							$piccounter++;
						}
					}
					//break;
				}
			}
			if ( $domnode->hasChildNodes() ) {
				//recall this function to search in subNodes
				domread_album($domnode, $array_ptr, $albumid, $piccounter);
			}
			//goto next node	 
			$domnode = $domnode->nextSibling;
		}
		return $piccounter;
	}
}

//******************
// Detect browser, from techpatterns.com under GNU/ GPL lesser license, note some browsers fail to parse http_user_agent, or firewalls block it
if(!function_exists('browser_detection')) {
	function browser_detection( $which_test ) {
		// Initialize the variables
		$browser = '';
		$dom_browser = '';
		// Set to lower case to avoid errors, check to see if http_user_agent is set
		$navigator_user_agent = ( isset( $_SERVER['HTTP_USER_AGENT'] ) ) ? strtolower( $_SERVER['HTTP_USER_AGENT'] ) : '';
		// No need to run through all the main browser possibilities, just FF
		if (stristr($navigator_user_agent, "gecko")) {
			$browser = 'mozilla';
			$dom_browser = true;
		}
		else {
		  $dom_browser = false;
		}
		// Return the test result you want
		if ( $which_test == 'browser' )	{
			return $browser;
		}
		elseif ( $which_test == 'dom' )	{
			return $dom_browser;
			// Note: $dom_browser is a boolean value, true/false, so you can just test if
			// it's true or not.
		}
	}
}

//******************
//sort a subarray
if(!function_exists('sortByFunc')) {
	function sortByFunc(&$arr, $func) {
		$tmpArr = array();
		foreach ($arr as $k => $e) {
			$tmpArr[] = array('f' => $func($e), 'k' => $k, 'e' =>$e);
		}
		rsort($tmpArr);
		$arr = array();
		foreach($tmpArr as $fke) {
			$arr[$fke['k']] = $fke['e'];
		}
	}
}

//******************
// search the moduleId in the database
//function get_ModuleId($ModuleName = "com_expose") {
	$query = "SELECT id"
			. "\n FROM #__menu"
			. "\n WHERE published = 1"
			. "\n AND link = 'index.php?option=com_expose'"
			. "\n ORDER BY link" ;
	$database->setQuery( $query );
	$Itemidobj = $database->loadObjectList();
	if (count($Itemidobj) > 0)
	$Itemid = $Itemidobj[0]->id;
// return $Itemid;
//}

//****************************************************************************
//****************** READ EXPOSE XML FILES ***********************************
//****************************************************************************
//if folder is just a number then analyze the Expose XML files
if(is_numeric($setPath)) { // && (count($aData) == 0)) {
	//open xml file, read the collection into array and return qty of records
	$indexcounter = 0;
	$total = domread_collection(domopen_file($ExposeXmlPath."albums.xml"), $cData, $indexcounter);
	//create empty array to fill with array result
	//static $aData = array();
	//if user wants random selection of pics, loop trough collection array and read all albums
	$indexcounter = 0;
	if ($total == 0) {
		//If  cData is emty (albums.xml doesn't exist or has no albums), it will generate an error in foreach()  so first check!
		echo "Error: Expose albums.xml not found or has no albums!";
	}
	elseif ($setPath == 0) {
		//loop trough all album files
		foreach ($cData as $ckey => $cvalue) {
			//open xml file, read the album into array and return qty of records  
//			echo 'File: '.$cData[$ckey]['contentxmlurl']."\n<br>";
			$total = domread_album(domopen_file($ExposeXmlPath.$cData[$ckey]['contentxmlurl']), $aData, $ckey, $indexcounter);
		}
	}
	//or read only selected album file if existing
	elseif (array_key_exists($setPath, $cData)) {
//	elseif ($ExposeXmlPath.$cData[$setPath]['contentxmlurl'] != '') {
		//open xml file, read the desired album into array and return qty of records
		$total = domread_album(domopen_file($ExposeXmlPath.$cData[$setPath]['contentxmlurl']), $aData, $setPath, $indexcounter);
	}	
	else {
		echo "Expose Album ID doesn't exist!";
		$total = 0;
	}
// Overview created arrays for troubleshooting
//	echo "\n<br>Collection: \n<br>"; print_r($cData); echo "\n<br>Album: \n<br>"; print_r($aData);
}
//****************************************************************************
//****************** READ FILES FROM DIRECTORY (NON-EXPOSE) ******************
//****************************************************************************
// not numeric: search in requested folder
else { //if (!is_numeric($setPath)) {
	//cleanup the provided path:
	//if folder includes livesite info, remove it
	if ( strpos($setPath, $mosConfig_live_site) === 0 ) $ImagePath = str_replace( $mosConfig_live_site, '', $setPath );
	//if folder includes absolute path, remove it
	if ( strpos($setPath, $mosConfig_absolute_path) === 0 ) $setPath= str_replace( $mosConfig_absolute_path, '', $setPath );
	//if folder doesnt contain leading slash, add it
	if ( strpos($setPath, '/') !== 0 ) $setPath = '/'. $setPath;
	//if folder doesnt contain trailing slash, add it
	if ( substr($setPath, -1, 1) != '/') $setPath = $setPath . '/';
	//get the files now! (returns qty of files found)
	$indexcounter = 0;
	$total = recursive_dir($mosConfig_absolute_path.$setPath, $setFileType, "", $aData, $setRecurceDirs, $indexcounter);

	// Overview created arrays for troubleshooting
	//  echo "\n<br>Directory: \n<br>"; print_r($aData);
	
	//adjust some settings because we're not searching in the expose-directory now
	$ExposeImgPath = $setPath;
	$setLinking = "off";
}
//****************** CHECK PIC-QTY ******************
//make sure PicsNum < pics found in directory
if ( $setPicsNum > $total ) $setPicsNum = $total;	
//if PicsNum = 0 then show all pics found
elseif ( $setPicsNum == 0) $setPicsNum = $total;
//****************** PREPARE HTML CODE ******************
//check for FF and set bugspace in other browsers to 0
if (( browser_detection( 'browser' ) !== 'mozilla' )) $setBugSpace='0';
// Generate appropriate spacing, depending on horizontal/vertical scroll direction.
if ( ($setDirection == 'left') || ($setDirection == 'right') || ($setDirection == 'horizontal') ) {
	$ffbugspace = '';
}
else {
	$ffbugspace = str_repeat ('<br/>', $setBugSpace + 1);
}
echo "\n<!-- ExposeScroller Module (Beta 1v0) starts here -->";
//use css?
if($setUseCss) echo"\n<style type='text/css'><!-- $setCssDef --></style>";
// Set the marquee parameters.
echo "\n<div class=\"expose_scroller\">";
if (($setDirection !== 'horizontal') && ($setDirection !== 'vertical')) {
	echo "<marquee behavior=\"scroll\" 
					align=\"center\"  
					direction=\"$setDirection\"  
					height=\"$setHeight\"
					width=\"$setWidth\"
					scrollamount=\"$setMarqueeAmount\" 
					scrolldelay=\"$setMarqueeDelay\" 
					truespeed";
	if ($setHoverPause) echo " onmouseover=this.stop() onmouseout=this.start() ";
	echo ">\n";
}

//****************** GENERATE HTML CODE ******************
//are there pics in the directory?
if (!$setPicsNum) echo _NO_IMAGES;
//add space before pictures (FFbug) if not static pics
elseif (($setDirection !== 'horizontal') || ($setDirection !== 'vertical')) echo "$ffbugspace";

//if showing the latast added pictures, then sort the array
if ($setPickMethod == 'latest') {
	sortByFunc($aData,create_function('$element','return $element["timestamp"];'));
	// Set the pointer to beginning of array
	reset($aData);
}

// Loop $setPicsNum times through the images
$picstack = '';
for ($i=0;$i<$setPicsNum;$i++) {
	// Search for a PictureId depending user settings
	if ($setPickMethod == 'filename') {
		//not very usefull, but...
		$picid=$i;
	}
	elseif ($setPickMethod == 'latest') {
		//use reverse-sorting: we'll need the id by array-pointer, not by referance
		$picid=key($aData);
		//prepare for next loop
		next($aData);
	}
	else {
		//random pick: prevent a photo from showing twice or more: check for unique picid
		do {
			$picid = rand(0,$total-1);
		} while (eregi($picid.'a', $picstack.'a'));
		//memorize used pics and check if already used; continou or get new picid
		$picstack = $picstack.'a'.$picid;
	}

	if(is_numeric($setPath)) {
		$Linkref=array('off'=>'',
				'collection'=>"<a href=\"".sefRelToAbs("index.php?option=com_expose&amp;Itemid=".$Itemid."&amp;topcoll=".$aData[$picid]['albumid'])."\">",
				'album'=>"<a href=\"".sefRelToAbs("index.php?option=com_expose&amp;Itemid=".$Itemid."&amp;album=".$aData[$picid]['albumid'])."\">",
				'photo'=>"<a href=\"".sefRelToAbs("index.php?option=com_expose&amp;Itemid=".$Itemid."&amp;album=".$aData[$picid]['albumid']."&amp;photo=".$aData[$picid]['photoid'])."\">",
				'slideshow'=>"<a href=\"".sefRelToAbs("index.php?option=com_expose&amp;Itemid=".$Itemid."&amp;album=".$aData[$picid]['albumid']."&amp;photo=".$aData[$picid]['photoid']."&amp;playslideshow=yes")."\">",
				'slideshowfirst'=>"<a href=\"".sefRelToAbs("index.php?option=com_expose&amp;Itemid=".$Itemid."&amp;album=".$aData[$picid]['albumid']."&amp;photo=1&amp;playslideshow=yes")."\">");
		$LinkEndref=array('off'=>'',
				'collection'=>'</a>',
				'album'=>'</a>',
				'photo'=>'</a>',
				'slideshow'=>'</a>',
				'slideshowfirst'=>'</a>');
		$Picref=array('horizontal'=>"<img src=\"".$mosConfig_live_site.$ExposeImgPath.$aData[$picid]['smallimage']."\" alt=\"".$cData[$aData[$picid]['albumid']]['title']." - ".$aData[$picid]['title']."\" height=\"$setHeight\"/>",
				'vertical'=>"<img src=\"".$mosConfig_live_site.$ExposeImgPath.$aData[$picid]['smallimage']."\" alt=\"".$cData[$aData[$picid]['albumid']]['title']." - ".$aData[$picid]['title']."\" width=\"$setWidth\"/>");

		//display and adjust the <img> tag depending scrolldirection
		//horizontal scrolling:
		if (($setDirection == 'left') || ($setDirection == 'right') || ($setDirection == 'horizontal')) {
			echo $Linkref[$setLinking].$Picref['horizontal'].$LinkEndref[$setLinking].str_repeat('&nbsp;', $setSpace+1)."\n";
		}
		//vertical scrolling:
		else {
			echo $Linkref[$setLinking].$Picref['vertical'].$LinkEndref[$setLinking].str_repeat('<br/>', $setSpace+1)."\n";
		}
	}
	else { // Scrolling folder pics: no linking, no descriptions available
		if (($setDirection == 'left') || ($setDirection == 'right') || ($setDirection == 'horizontal')) {
			echo "<img src=\"".$mosConfig_live_site.$ExposeImgPath.$aData[$picid]['smallimage']."\" alt=\"".$aData[$picid]['title']."\" height=\"$setHeight\"/>".str_repeat('&nbsp;', $setSpace+1)."\n";
		}
		//vertical scrolling:
		else {
			echo "<img src=\"".$mosConfig_live_site.$ExposeImgPath.$aData[$picid]['smallimage']."\" alt=\"".$aData[$picid]['title']."\" width=\"$setWidth\"/>".str_repeat('<br/>', $setSpace+1)."\n";
		}	
	}	
}

//fill the gap for Firefox
if (($setDirection !== 'horizontal') || ($setDirection !== 'vertical')) echo "$ffbugspace";
echo '</marquee></div>';
echo "\n<!-- ExposeScroller Module (Beta 1v0) ends here -->";
?>
